"""Initial volumes for each network"""

from os import path as P, makedirs as mkdir_p
from shutil import rmtree
from yaml import dump_all as yaml_dump, safe_load as yaml_load, Dumper
from requests import get as wget
try:
    from kmama.core.generic import DRYRUN, CONFIG, CLI, VERBOSITY, common_settings
    from kmama.core.execution import sub_process_run
    from kmama.utilities import cprint, DotDict
except ImportError:
    from sys import path as sys_path
    sys_path.insert(1, P.normpath(P.join(P.dirname(P.abspath(__file__)), "..")))
    from core.generic import DRYRUN, CONFIG, CLI, VERBOSITY, common_settings
    from core.execution import sub_process_run
    from utilities import cprint, DotDict



def set_volume_salt_url(args, validated):
    """Salt URL"""
    cprint("DEBUG: Set automount.yml salt url", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get('automounts_url'):
        args.target_url = CONFIG.volumes.automounts_url
    else:
        args.target_url = "https://osug.gricad-pages.univ-grenoble-alpes.fr/RESIF/salt/pillarstack/profiles/automount.yml"
    cprint(f"DEBUG: ... url: {args.target_url}", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_storage_capacity(args, validated):
    """Storage capacity"""
    cprint("DEBUG: Set storage capacity for PV/PVC", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get("storage_capacity"):
        args.storage_capacity = CONFIG.volumes.storage_capacity
    else:
        args.storage_capacity = "100Ti"
    cprint(f"DEBUG: ... storage capacity: {args.storage_capacity}", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_nfs_server(args, validated):
    """NFS Server"""
    cprint("DEBUG: Set NFS server IP", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get('nfs_server'):
        args.nfs_server = CONFIG.volumes.nfs_server
    else:
        args.nfs_server = "152.77.136.3"
    cprint(f"DEBUG: ... IP: {args.nfs_server}", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_access_modes(args, validated):
    """Access modes (should be a list)"""
    cprint("DEBUG: Set access modes for PV/PVC", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get("access_modes"):
        args.access_modes = CONFIG.volumes.access_modes
        if not isinstance(args.access_modes, list):
            cprint("INFORMATION: Converting the 'access mode' to a 'list' type", CLI.verbose)
            args.access_modes = [args.access_modes]
    else:
        args.access_modes = ["ReadOnlyMany"]
    cprint(f"DEBUG: ... access modes: {args.access_modes} (list)", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_mount_options(args, validated):
    """Mount options (should be a list)"""
    cprint("DEBUG: Set mount options for PV/PVC", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get("mount_options"):
        args.mount_options = CONFIG.volumes.mount_options
        if not isinstance(args.mount_options, list):
            cprint("INFORMATION: Converting the 'mount options' to a 'list' type", CLI.verbose)
            args.mount_options = [args.mount_options]
    else:
        args.mount_options = ["nfsvers=3", "ro", "tcp", "soft"]
    cprint(f"DEBUG: ... mount options: {args.mount_options} (list)", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_reclaim_policy(args, validated):
    """Reclaim policy"""
    cprint("DEBUG: Set reclaim policy", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get('reclaim_policy'):
        args.reclaim_policy = CONFIG.volumes.reclaim_policy
    else:
        args.reclaim_policy = "Retain"
    cprint(f"DEBUG: ... reclaim policy: {args.reclaim_policy}", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def set_volume_mode(args, validated):
    """Volume mode"""
    cprint("DEBUG: Set volume mode", CLI.verbose > VERBOSITY.INFO)
    if CONFIG.get("volumes") and CONFIG.volumes.get('volume_mode'):
        args.volume_mode = CONFIG.volumes.volume_mode
    else:
        args.volume_mode = "Filesystem"
    cprint(f"DEBUG: ... volume mode: {args.volume_mode}", CLI.verbose > VERBOSITY.WARNING)
    return args, validated


def create_resif_dynamic_volumes(args):
    """Retrieves information to create dynamic volumes"""
    # Get automount.yml as dictionnary
    cprint("DEBUG: Start creating PV/PVC (generated by network)", CLI.verbose > VERBOSITY.INFO)
    automount_yaml = yaml_load(wget(args.target_url).text)
    # Build dict
    cprint("DEBUG: ... build dict values for each network", CLI.verbose > VERBOSITY.WARNING)
    config = DotDict()
    config.context = args.context
    config.volume_mode = args.volume_mode
    config.storage_capacity = args.storage_capacity
    config.access_modes = args.access_modes
    config.reclaim_policy = args.reclaim_policy
    config.mount_options = args.mount_options
    config.nfs_server = args.nfs_server
    for data_type, data_content in automount_yaml['automounts'].items():
        if data_type not in CONFIG.contexts[args.context].resifDynamicVolumes:
            cprint(f"INFORMATION: Data-type value {data_type!r} not found in configuration files", CLI.verbose)
            continue
        config.data_type = data_type
        for network, content in data_content.items():
            config.volume_name = f"{data_type}-data-{network.lower()}"
            if data_type == "bynet":
                config.volume_name = f"validated-data-{network.lower()}"
            config.mount_path = f"/{content['target'].rsplit('/mnt/nfs/summer/')[1]}"
            config.labels = {
                "resifDynamicVolumes": f"data-{data_type}",
                "netcode": f"{network.lower()}",
            }
            # Summary and execution
            cprint(f"DEBUG: Generating volume:\n\t{config.volume_name}; {config.mount_path}", CLI.verbose > VERBOSITY.INFO)
            write_volumes(args, config)


def create_resif_context_volumes(args):
    """Retrieves information to create contexts volumes"""
    cprint("DEBUG: Start creating PV/PVC (context-specific)", CLI.verbose > VERBOSITY.INFO)
    for volume in CONFIG.contexts[args.context].resifContextVolumes:
        if not volume.get('name') or not volume.get('mount_path'):
            cprint(f"WARNING: Name or MountPath missing in {volume}")
            continue
        config = DotDict()
        config.context = args.context
        config.volume_name = str(volume.name)
        config.mount_path = str(volume.mount_path)
        config.volume_mode = volume.get('volume_mode') or args.volume_mode
        config.storage_capacity = volume.get('storage_capacity') or args.storage_capacity
        config.access_modes = volume.get('access_modes') or args.access_modes
        config.reclaim_policy = volume.get('reclaim_policy') or args.reclaim_policy
        config.mount_options = volume.get('mount_options') or args.mount_options
        config.nfs_server = volume.get('nfs_server') or args.nfs_server
        config.labels = volume.get('labels')
        # Summary and execution
        cprint(f"DEBUG: Generating volume:\n\t{config.volume_name}; {config.mount_path}", CLI.verbose > VERBOSITY.INFO)
        write_volumes(args, config)



def main_volume():
    """Create default PV/PVC on k8s cluster"""
    # Builds the "args" dictionary containing the information common to the whole program
    args, validated = common_settings()
    # Updates the "args" dictionary with volumes configurations
    args, validated = set_volume_salt_url(args, validated)
    args, validated = set_volume_storage_capacity(args, validated)
    args, validated = set_volume_nfs_server(args, validated)
    args, validated = set_volume_access_modes(args, validated)
    args, validated = set_volume_mount_options(args, validated)
    args, validated = set_volume_reclaim_policy(args, validated)
    args, validated = set_volume_mode(args, validated)
    if not validated:
        cprint("ERROR: Current configuration invalid")
        return
    # Clean and/or create volumes directory
    rmtree(args.volumes_directory, ignore_errors=True)
    mkdir_p(args.volumes_directory)
    if CONFIG.get("contexts") and CONFIG.contexts.get(args.context):
        # Build volumes from salt automount.yaml
        if CONFIG.contexts[args.context].get("resifDynamicVolumes"):
            cprint("INFORMATION: Configuration of volumes defined in the automount configuration", CLI.verbose)
            create_resif_dynamic_volumes(args)
        # Build other volumes
        if CONFIG.contexts[args.context].get("resifContextVolumes"):
            cprint(f"INFORMATION: Configuration of volumes defined for the {args.context!r} context.", CLI.verbose)
            create_resif_context_volumes(args)
    else:
        cprint("INFORMATION: No volumes required for the specified context", CLI.verbose)


def build_pv_dict(config):
    cprint("DEBUG: Build PV dict", CLI.verbose > VERBOSITY.INFO)
    pv_dict = DotDict({
        "apiVersion": "v1",
        "kind": "PersistentVolume",
        "metadata": {
            "name": f"{config.context}-{config.volume_name}-pv",
            "labels": {
                "context": config.context,
                "volume": config.volume_name,
            },
        },
        "spec": {
            "volumeMode": config.volume_mode,
            "capacity": {
                "storage": config.storage_capacity,
            },
            "accessModes": config.access_modes, # Should be a List, not a String
            "persistentVolumeReclaimPolicy": config.reclaim_policy,
            "mountOptions": config.mount_options, # Should be a List, not a String
            "nfs": {
                "path": config.mount_path,
                "server": config.nfs_server,
            },
        },
    })
    if config.get('labels'):
        pv_dict.metadata.labels.update(config.labels)
    return pv_dict


def build_pvc_dict(config):
    cprint("DEBUG: Build PVC dict", CLI.verbose > VERBOSITY.INFO)
    pvc_dict = DotDict({
        "apiVersion": "v1",
        "kind": "PersistentVolumeClaim",
        "metadata": {
            "name": f"{config.context}-{config.volume_name}-pvc",
            "namespace": config.context,
            "labels": {
                "context": config.context,
                "volume": config.volume_name,
            },
        },
        "spec": {
            "resources": {
                "requests": {
                    "storage": config.storage_capacity,
                },
            },
            "accessModes": config.access_modes, # Should be a List, not a String
            "storageClassName": "",
            "volumeName": f"{config.context}-{config.volume_name}-pv", # Should be a List, not a String
        },
    })
    if config.get('labels'):
        pvc_dict.metadata.labels.update(config.labels)
    return pvc_dict


def write_volumes(args, config):
    cprint("DEBUG: Write and apply manifest", CLI.verbose > VERBOSITY.INFO)
    pv_dict = build_pv_dict(config)
    pvc_dict = build_pvc_dict(config)
    if args.context != DRYRUN:
        file_path = P.join(args.volumes_directory, f"{config.volume_name}.yaml")
        with open(file_path, 'w', encoding='utf-8') as f_write:
            yaml_dump([pv_dict.to_dict(), pvc_dict.to_dict()], f_write, Dumper=Dumper)
        sub_process_run(f"kubectl --kubeconfig {args.kubeconfig} --namespace {args.context} apply -f {file_path}", args.context)
    cprint(f"DEBUG: {config.volume_name}.yaml created and deployed", CLI.verbose > VERBOSITY.INFO)
